<html>
  <head>
    <meta charset="utf-8"/>
    <link rel="stylesheet" href="my.css">
  </head>
    <!-- go -->
    <body>
        <h1>WASM Experiments</h1>
        <h2>👋 Open the developer tools 😃</h2>
        <script> 
            // every language support should provide something like this
            let importObject = {
              wasi_snapshot_preview1: {
                fd_write: () => 0,
              }
            }
            // https://dev.to/ndesmic/building-a-minimal-wasi-polyfill-for-browsers-4nel
            // https://blog.jeremylikness.com/blog/explore-wasi-from-your-browser/
            

            // Load the wasm file (3)
            WebAssembly.instantiateStreaming(fetch("main.wasm"), importObject) 
              .then(({ instance }) => {
                // call the function (4)
                console.log("📦 Wasm Module Instance", instance)
                const value = instance.exports.add(2, 2)
                console.log("🤖 add(2,2):", value)
                console.log('👋 hello("Bob"):', instance.exports.hello("Bob"))
                
              })
              .catch(error => {
                console.log("😡 ouch", error)
              })
            
        </script>
  </body>
</html>
